Package org.zkoss.lang

## Class PotentialDeadLockException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - java.lang.RuntimeException
      - - org.zkoss.lang.SystemException
        - - org.zkoss.lang.OperationException
          - - org.zkoss.lang.PotentialDeadLockException

- All Implemented Interfaces:
    `java.io.Serializable`, `Expectable`, `Messageable`, `MessageConst`

      public class PotentialDeadLockException
      extends OperationException

  Denote a potential dead lock might occur. More precisely, it occurs if a transaction is waiting a lock too long.

  How it happens:
  Transaction A writes bean X and transaction B writes bean Y, and then A tries to read or write bean Y and B tries to read or write bean X.

  This exception shall be rare, because CmpManager sorted beans to be updated in a special order. However, it still might happen, because a transaction might trigger multiple syncBeans.

  Author:
    tomyeh
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.zkoss.lang.SystemException

      `SystemException.Aide`

    - ### Nested classes/interfaces inherited from interface org.zkoss.mesg.MessageConst

      `MessageConst.BundleInfo`

  - ### Field Summary

    - ### Fields inherited from class org.zkoss.lang.SystemException

      `_code`

    - ### Fields inherited from interface org.zkoss.mesg.MessageConst

      `NULL_CODE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PotentialDeadLockException()` |
    `PotentialDeadLockException​(int code)` |
    `PotentialDeadLockException​(int code, java.lang.Object fmtArg)` |
    `PotentialDeadLockException​(int code, java.lang.Object[] fmtArgs)` |
    `PotentialDeadLockException​(int code, java.lang.Object[] fmtArgs, java.lang.Throwable cause)` |
    `PotentialDeadLockException​(int code, java.lang.Object fmtArg, java.lang.Throwable cause)` |
    `PotentialDeadLockException​(int code, java.lang.Throwable cause)` |
    `PotentialDeadLockException​(java.lang.String s)` |
    `PotentialDeadLockException​(java.lang.String msg, java.lang.Throwable cause)` |
    `PotentialDeadLockException​(java.lang.Throwable cause)` |

  - ### Method Summary

    - ### Methods inherited from class org.zkoss.lang.SystemException

      `getCode`

    - ### Methods inherited from class java.lang.Throwable

      `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PotentialDeadLockException

          public PotentialDeadLockException​(java.lang.String msg,
                                            java.lang.Throwable cause)

    - #### PotentialDeadLockException

          public PotentialDeadLockException​(java.lang.String s)

    - #### PotentialDeadLockException

          public PotentialDeadLockException​(java.lang.Throwable cause)

    - #### PotentialDeadLockException

          public PotentialDeadLockException()

    - #### PotentialDeadLockException

          public PotentialDeadLockException​(int code,
                                            java.lang.Object[] fmtArgs,
                                            java.lang.Throwable cause)

    - #### PotentialDeadLockException

          public PotentialDeadLockException​(int code,
                                            java.lang.Object fmtArg,
                                            java.lang.Throwable cause)

    - #### PotentialDeadLockException

          public PotentialDeadLockException​(int code,
                                            java.lang.Object[] fmtArgs)

    - #### PotentialDeadLockException

          public PotentialDeadLockException​(int code,
                                            java.lang.Object fmtArg)

    - #### PotentialDeadLockException

          public PotentialDeadLockException​(int code,
                                            java.lang.Throwable cause)

    - #### PotentialDeadLockException

          public PotentialDeadLockException​(int code)